Velocity (Velocity 1.7 API)
Keywords: org.apache.velocity.app.Velocity class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.velocity.app
Class Velocity

    java.lang.Object
      org.apache.velocity.app.Velocity

All Implemented Interfaces:
  RuntimeConstants

public class Velocity
extends Object
implements RuntimeConstants

This class provides services to the application developer, such as :

- Simple Velocity Runtime engine initialization methods.
- Functions to apply the template engine to streams and strings to allow embedding and dynamic template generation.
- Methods to access Velocimacros directly.

While the most common way to use Velocity is via templates, as Velocity is a general-purpose template engine, there are other uses that Velocity is well suited for, such as processing dynamically created templates, or processing content streams.
The methods herein were developed to allow easy access to the Velocity facilities without direct spelunking of the internals. If there is something you feel is necessary to add here, please, send a patch.

Version:
  $Id: Velocity.java 898050 2010-01-11 20:15:31Z nbubna $
Author:
  Geir Magnusson Jr., Christoph Reck, Jason van Zyl

Field Summary

Fields inherited from interface org.apache.velocity.runtime.RuntimeConstants
`COUNTER_INITIAL_VALUE, COUNTER_NAME, DEBUG_PREFIX, DEFAULT_RUNTIME_DIRECTIVES, DEFAULT_RUNTIME_PROPERTIES, DEFINE_DIRECTIVE_MAXDEPTH, DIRECTIVE_IF_TOSTRING_NULLCHECK, ENCODING_DEFAULT, ERROR_PREFIX, ERRORMSG_END, ERRORMSG_START, EVALUATE_CONTEXT_CLASS, EVENTHANDLER_INCLUDE, EVENTHANDLER_INVALIDREFERENCES, EVENTHANDLER_METHODEXCEPTION, EVENTHANDLER_NULLSET, EVENTHANDLER_REFERENCEINSERTION, FILE_RESOURCE_LOADER_CACHE, FILE_RESOURCE_LOADER_PATH, HAS_NEXT_NAME, INFO_PREFIX, INPUT_ENCODING, INTERPOLATE_STRINGLITERALS, INTROSPECTOR_RESTRICT_CLASSES, INTROSPECTOR_RESTRICT_PACKAGES, MAX_NUMBER_LOOPS, NUMBER_OF_PARSERS, OUTPUT_ENCODING, PARSE_DIRECTIVE_MAXDEPTH, PARSER_POOL_CLASS, PARSER_POOL_SIZE, PROVIDE_SCOPE_CONTROL, RESOURCE_LOADER, RESOURCE_MANAGER_CACHE_CLASS, RESOURCE_MANAGER_CLASS, RESOURCE_MANAGER_DEFAULTCACHE_SIZE, RESOURCE_MANAGER_LOGWHENFOUND, RUNTIME_LOG, RUNTIME_LOG_ERROR_STACKTRACE, RUNTIME_LOG_INFO_STACKTRACE, RUNTIME_LOG_LOGSYSTEM, RUNTIME_LOG_LOGSYSTEM_CLASS, RUNTIME_LOG_REFERENCE_LOG_INVALID, RUNTIME_LOG_WARN_STACKTRACE, RUNTIME_REFERENCES_STRICT, RUNTIME_REFERENCES_STRICT_ESCAPE, SET_NULL_ALLOWED, SKIP_INVALID_ITERATOR, STRICT_MATH, TRACE_PREFIX, UBERSPECT_CLASSNAME, UNKNOWN_PREFIX, VM_ARGUMENTS_STRICT, VM_BODY_REFERENCE, VM_CONTEXT_LOCALSCOPE, VM_LIBRARY, VM_LIBRARY_AUTORELOAD, VM_LIBRARY_DEFAULT, VM_MAX_DEPTH, VM_MESSAGES_ON, VM_PERM_ALLOW_INLINE, VM_PERM_ALLOW_INLINE_REPLACE_GLOBAL, VM_PERM_INLINE_LOCAL, WARN_PREFIX`

Constructor Summary
`Velocity()`

Method Summary
`static void` | `addProperty(String key, Object value)` Add a Velocity Runtime property.
`static void` | `clearProperty(String key)` Clear a Velocity Runtime property.
`static void` | `debug(Object message)` Deprecated. Use getLog() and call debug() on it.
`static void` | `error(Object message)` Deprecated. Use getLog() and call error() on it.
`static boolean` | `evaluate(Context context, Writer writer, String logTag, InputStream instream)` Deprecated. Use `evaluate( Context context, Writer writer, String logTag, Reader reader )`
`static boolean` | `evaluate(Context context, Writer writer, String logTag, Reader reader)` Renders the input reader using the context into the output writer.
`static boolean` | `evaluate(Context context, Writer out, String logTag, String instring)` renders the input string using the context into the output writer.
`static Log` | `getLog()` Returns a convenient Log instance that wraps the current LogChute.
`static Object` | `getProperty(String key)` Get a Velocity Runtime property.
`static Template` | `getTemplate(String name)` Returns a `Template` from the Velocity resource management system.
`static Template` | `getTemplate(String name, String encoding)` Returns a `Template` from the Velocity resource management system.
`static void` | `info(Object message)` Deprecated. Use getLog() and call info() on it.
`static void` | `init()` initialize the Velocity runtime engine, using the default properties of the Velocity distribution
`static void` | `init(Properties p)` initialize the Velocity runtime engine, using default properties plus the properties in the passed in java.util.Properties object
`static void` | `init(String propsFilename)` initialize the Velocity runtime engine, using default properties plus the properties in the properties file passed in as the arg
`static boolean` | `invokeVelocimacro(String vmName, String logTag, String[] params, Context context, Writer writer)` Invokes a currently registered Velocimacro with the params provided and places the rendered stream into the writer.
`void` | `loadDirective(String directiveClass)` Instantiates and loads the directive with some basic checks.
`static boolean` | `mergeTemplate(String templateName, Context context, Writer writer)` Deprecated. Use `mergeTemplate( String templateName, String encoding, Context context, Writer writer )`
`static boolean` | `mergeTemplate(String templateName, String encoding, Context context, Writer writer)` merges a template and puts the rendered stream into the writer
`void` | `removeDirective(String name)` Remove a directive.
`static boolean` | `resourceExists(String resourceName)` Determines whether a resource is accessable via the currently configured resource loaders.
`static void` | `setApplicationAttribute(Object key, Object value)` Set the an ApplicationAttribue, which is an Object set by the application which is accessable from any component of the system that gets a RuntimeServices.
`static void` | `setExtendedProperties(ExtendedProperties configuration)` Set an entire configuration at once.
`static void` | `setProperty(String key, Object value)` Set a Velocity Runtime property.
`static boolean` | `templateExists(String resourceName)` Deprecated. Use resourceExists(String) instead.
`static void` | `warn(Object message)` Deprecated. Use getLog() and call warn() on it.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Velocity

    public Velocity()

Method Detail

### init

    public static void init()

  initialize the Velocity runtime engine, using the default properties of the Velocity distribution

### init

    public static void init(String propsFilename)

  initialize the Velocity runtime engine, using default properties plus the properties in the properties file passed in as the arg

  Parameters:
    `propsFilename` - file containing properties to use to initialize the Velocity runtime

### init

    public static void init(Properties p)

  initialize the Velocity runtime engine, using default properties plus the properties in the passed in java.util.Properties object

  Parameters:
    `p` - Properties object containing initialization properties

### setProperty

    public static void setProperty(String key,
                                   Object value)

  Set a Velocity Runtime property.

  Parameters:
    `key` - The property key.
    `value` - The property value.

### addProperty

    public static void addProperty(String key,
                                   Object value)

  Add a Velocity Runtime property.

  Parameters:
    `key` - The property key.
    `value` - The property value.

### clearProperty

    public static void clearProperty(String key)

  Clear a Velocity Runtime property.

  Parameters:
    `key` - of property to clear

### setExtendedProperties

    public static void setExtendedProperties(ExtendedProperties configuration)

  Set an entire configuration at once. This is useful in cases where the parent application uses the ExtendedProperties class and the velocity configuration is a subset of the parent application's configuration.

  Parameters:
    `configuration` - A configuration object.

### getProperty

    public static Object getProperty(String key)

  Get a Velocity Runtime property.

  Parameters:
    `key` - property to retrieve
  Returns:
    property value or null if the property not currently set

### evaluate

    public static boolean evaluate(Context context,
                                   Writer out,
                                   String logTag,
                                   String instring)
                            throws ParseErrorException,
                                   MethodInvocationException,
                                   ResourceNotFoundException

  renders the input string using the context into the output writer. To be used when a template is dynamically constructed, or want to use Velocity as a token replacer.

  Parameters:
    `context` - context to use in rendering input string
    `out` - Writer in which to render the output
    `logTag` - string to be used as the template name for log messages in case of error
    `instring` - input string containing the VTL to be rendered
  Returns:
    true if successful, false otherwise. If false, see Velocity runtime log
  Throws:
    `ParseErrorException` - The template could not be parsed.
    `MethodInvocationException` - A method on a context object could not be invoked.
    `ResourceNotFoundException` - A referenced resource could not be loaded.

### evaluate

    public static boolean evaluate(Context context,
                                   Writer writer,
                                   String logTag,
                                   InputStream instream)
                            throws ParseErrorException,
                                   MethodInvocationException,
                                   ResourceNotFoundException

  Deprecated. Use `evaluate( Context context, Writer writer, String logTag, Reader reader )`

  Renders the input stream using the context into the output writer. To be used when a template is dynamically constructed, or want to use Velocity as a token replacer.

  Parameters:
    `context` - context to use in rendering input string
    `writer` - Writer in which to render the output
    `logTag` - string to be used as the template name for log messages in case of error
    `instream` - input stream containing the VTL to be rendered
  Returns:
    true if successful, false otherwise. If false, see Velocity runtime log
  Throws:
    `ParseErrorException` - The template could not be parsed.
    `MethodInvocationException` - A method on a context object could not be invoked.
    `ResourceNotFoundException` - A referenced resource could not be loaded.
    `IOException` - While loading a reference, an I/O problem occured.

### evaluate

    public static boolean evaluate(Context context,
                                   Writer writer,
                                   String logTag,
                                   Reader reader)
                            throws ParseErrorException,
                                   MethodInvocationException,
                                   ResourceNotFoundException

  Renders the input reader using the context into the output writer. To be used when a template is dynamically constructed, or want to use Velocity as a token replacer.

  Parameters:
    `context` - context to use in rendering input string
    `writer` - Writer in which to render the output
    `logTag` - string to be used as the template name for log messages in case of error
    `reader` - Reader containing the VTL to be rendered
  Returns:
    true if successful, false otherwise. If false, see Velocity runtime log
  Throws:
    `ParseErrorException` - The template could not be parsed.
    `MethodInvocationException` - A method on a context object could not be invoked.
    `ResourceNotFoundException` - A referenced resource could not be loaded.
  Since:
    Velocity v1.1

### invokeVelocimacro

    public static boolean invokeVelocimacro(String vmName,
                                            String logTag,
                                            String[] params,
                                            Context context,
                                            Writer writer)

  Invokes a currently registered Velocimacro with the params provided and places the rendered stream into the writer.
  Note : currently only accepts args to the VM if they are in the context.

  Parameters:
    `vmName` - name of Velocimacro to call
    `logTag` - string to be used for template name in case of error. if null, the vmName will be used
    `params` - keys for args used to invoke Velocimacro, in java format rather than VTL (eg "foo" or "bar" rather than "$foo" or "$bar")
    `context` - Context object containing data/objects used for rendering.
    `writer` - Writer for output stream
  Returns:
    true if Velocimacro exists and successfully invoked, false otherwise.

### mergeTemplate

    public static boolean mergeTemplate(String templateName,
                                        Context context,
                                        Writer writer)
                                 throws ResourceNotFoundException,
                                        ParseErrorException,
                                        MethodInvocationException

  Deprecated. Use `mergeTemplate( String templateName, String encoding, Context context, Writer writer )`

  Merges a template and puts the rendered stream into the writer. The default encoding that Velocity uses to read template files is defined in the property input.encoding and defaults to ISO-8859-1.

  Parameters:
    `templateName` - name of template to be used in merge
    `context` - filled context to be used in merge
    `writer` - writer to write template into
  Returns:
    true if successful, false otherwise. Errors logged to velocity log.
  Throws:
    `ParseErrorException` - The template could not be parsed.
    `MethodInvocationException` - A method on a context object could not be invoked.
    `ResourceNotFoundException` - A referenced resource could not be loaded.

### mergeTemplate

    public static boolean mergeTemplate(String templateName,
                                        String encoding,
                                        Context context,
                                        Writer writer)
                                 throws ResourceNotFoundException,
                                        ParseErrorException,
                                        MethodInvocationException

  merges a template and puts the rendered stream into the writer

  Parameters:
    `templateName` - name of template to be used in merge
    `encoding` - encoding used in template
    `context` - filled context to be used in merge
    `writer` - writer to write template into
  Returns:
    true if successful, false otherwise. Errors logged to velocity log
  Throws:
    `ParseErrorException` - The template could not be parsed.
    `MethodInvocationException` - A method on a context object could not be invoked.
    `ResourceNotFoundException` - A referenced resource could not be loaded.
  Since:
    Velocity v1.1

### getTemplate

    public static Template getTemplate(String name)
                                throws ResourceNotFoundException,
                                       ParseErrorException

  Returns a `Template` from the Velocity resource management system.

  Parameters:
    `name` - The file name of the desired template.
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.

### getTemplate

    public static Template getTemplate(String name,
                                       String encoding)
                                throws ResourceNotFoundException,
                                       ParseErrorException

  Returns a `Template` from the Velocity resource management system.

  Parameters:
    `name` - The file name of the desired template.
    `encoding` - The character encoding to use for the template.
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.
  Since:
    Velocity v1.1

### resourceExists

    public static boolean resourceExists(String resourceName)

  Determines whether a resource is accessable via the currently configured resource loaders. `Resource` is the generic description of templates, static content, etc.

  Note that the current implementation will not change the state of the system in any real way - so this cannot be used to pre-load the resource cache, as the previous implementation did as a side-effect.

  Parameters:
    `resourceName` - The name of the resource to search for.
  Returns:
    Whether the resource was located.

### getLog

    public static Log getLog()

  Returns a convenient Log instance that wraps the current LogChute. Use this to log error messages. It has the usual methods.

  Returns:
    A convenience Log instance that wraps the current LogChute.
  Since:
    1.5

### warn

    public static void warn(Object message)

  Deprecated. Use getLog() and call warn() on it.

  Parameters:
    `message` - The message to log.
  See Also:
    `Log.warn(Object)`

### info

    public static void info(Object message)

  Deprecated. Use getLog() and call info() on it.

  Parameters:
    `message` - The message to log.
  See Also:
    `Log.info(Object)`

### error

    public static void error(Object message)

  Deprecated. Use getLog() and call error() on it.

  Parameters:
    `message` - The message to log.
  See Also:
    `Log.error(Object)`

### debug

    public static void debug(Object message)

  Deprecated. Use getLog() and call debug() on it.

  Parameters:
    `message` - The message to log.
  See Also:
    `Log.debug(Object)`

### setApplicationAttribute

    public static void setApplicationAttribute(Object key,
                                               Object value)

  Set the an ApplicationAttribue, which is an Object set by the application which is accessable from any component of the system that gets a RuntimeServices. This allows communication between the application environment and custom pluggable components of the Velocity engine, such as loaders and loggers.

  Note that there is no enfocement or rules for the key used - it is up to the application developer. However, to help make the intermixing of components possible, using the target Class name (e.g. com.foo.bar ) as the key might help avoid collision.

  Parameters:
    `key` - object 'name' under which the object is stored
    `value` - object to store under this key

### templateExists

    public static boolean templateExists(String resourceName)

  Deprecated. Use resourceExists(String) instead.

  Parameters:
    `resourceName` - Name of the Template to check.
  Returns:
    True if the template exists.
  See Also:
    `resourceExists(String)`

### removeDirective

    public void removeDirective(String name)

  Remove a directive.

  Parameters:
    `name` - name of the directive.

### loadDirective

    public void loadDirective(String directiveClass)

  Instantiates and loads the directive with some basic checks.

  Parameters:
    `directiveClass` - classname of directive to load

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2010 Apache Software Foundation. All Rights Reserved.